﻿// 
// This is the source code of Telegram for Windows Phone v. 3.x.x.
// It is licensed under GNU GPL v. 2 or later.
// You should have received a copy of the license in this archive (see LICENSE).
// 
// Copyright Evgeny Nadymov, 2013-present.
// 
using System;
using Telegram.Api.TL;

namespace Telegram.Api.Services
{
    public enum RequestStatus
    {
        Sent,
        Confirmed,
        Failed,
        ReadyToSend
    }

    public class HistoryItem
    {
        public long Hash { get { return Message != null ? Message.MessageId.Value : 0; } }
        public TLTransportMessageWithIdBase Message { get; set; }
        public TLObject Object { get; set; }
        public string Caption { get; set; }
        public DateTime SendTime { get; set; }
        public int TimeToResend { get; set; }
        public DateTime? SendBeforeTime { get; set; }
        public RequestStatus Status { get; set; }
        public Action<TLObject> Callback { get; set; }
        public Action FastCallback { get; set; }
        public Action<int> AttemptFailed { get; set; }
        public Action<TLRPCError> FaultCallback { get; set; }
        public Action<TLRPCError> FaultQueueCallback { get; set; }
        public long ClientTicksDelta { get; set; }
        public HistoryItem InvokeAfter { get; set; }
        public TLRPCError LastError { get; set; }

        public int DCId { get; set; }

        //public volatile bool IsSending;

        public override string ToString()
        {

            return string.Format("{0:HH:mm:ss.fff} dc_id={1} {2} hash={3}", SendTime, DCId, Caption, GetHashCode());
        }
    }
}